import "./jquery_world";
import React, { Component } from "react";
import { createRoot } from "react-dom/client";
import { DnD } from "./dnd";
import { Form } from "./form";
import { SearchHeaderPlugin } from "search_header_plugin";

/**
 * Clear sessionStorage on reload.
 */
if (performance.navigation.type == performance.navigation.TYPE_RELOAD) {
  sessionStorage.clear();
  history.replaceState(null, "", location.href.split("?")[0]);
}

class Page extends Component {
  componentDidMount() {
    this.refs.dnd.setState({ query: this.refs.form.refs.query });
  }
  render() {
    return (
      <div>
        <SearchHeaderPlugin />
        <DnD ref="dnd" />
        <Form ref="form" />
      </div>
    );
  }
}

const root = createRoot(document.getElementById("view"));
root.render(<Page />);
